---
title: VideoTrackList.onchange
slug: Web/API/VideoTrackList/onchange
tags:
  - API
  - Adding Tracks
  - Adding Video Tracks
  - Event Handler
  - HTML DOM
  - Media
  - Property
  - Reference
  - Video
  - VideoTrackList
  - addTrack
  - onchange
  - track
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("VideoTrackList")}}</strong> property <strong><code>onchange</code></strong> is an event handler which is called when the {{event("change")}} event occurs, indicating that a {{domxref("VideoTrack")}} in the <code>VideoTrackList</code> has been made active.</span></p>

<p>The event is passed into the event handler in the form of an {{domxref("Event")}} object; the event doesn't provide any additional information. To determine the new state of media's tracks, you'll have to look at their {{domxref("VideoTrack.selected")}} flags.</p>

<div class="note">
<p><strong>Note:</strong> You can also add a handler for the <code>change</code> event using {{domxref("EventTarget.addEventListener", "addEventListener()")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>VideoTrackList</em>.onchange = <em>eventHandler</em>;</pre>

<h3 id="Value">Value</h3>

<p>Set <code>onchange</code> to a function that should be called whenever a track is made active.</p>

<h2 id="Example">Example</h2>

<p>This snippet establishes a handler for the {{event("change")}} event that looks at each of the tracks in the list, calling a function to update the state of a user interface control that indicates the current state of the track.</p>

<pre class="brush: js">var trackList = document.querySelector("video").videoTracks;

trackList.onchange = function(event) {
  trackList.forEach(function(track) {
    updateTrackSelectedButton(track.id, track.selected);
  });
};
</pre>

<p>The <code>updateTrackSelectedButton()</code>, in this example, should be a function that finds a user interface control using the track's {{domxref("VideoTrack.id", "id")}} (perhaps the app uses the track ID as the control element's ID) and the track's {{domxref("VideoTrack.selected", "selected")}} flag to determine which state the control should be in now.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#handler-tracklist-onchange', 'VideoTrackList: onchange')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.VideoTrackList.onchange")}}</p>
